package com.loafle.overflow.service.central.discovery;

import java.util.Date;

import com.loafle.overflow.core.annotation.ProbeAPI;
import com.loafle.overflow.core.annotation.WebappAPI;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.discovery.DiscoverHost;
import com.loafle.overflow.model.discovery.DiscoverPort;
import com.loafle.overflow.model.discovery.DiscoverService;
import com.loafle.overflow.model.discovery.DiscoverZone;
import com.loafle.overflow.model.discovery.Host;
import com.loafle.overflow.model.discovery.Port;
import com.loafle.overflow.model.discovery.Service;
import com.loafle.overflow.model.discovery.Zone;

/**
 * Created by snoop on 17. 9. 28.
 */
public interface DiscoveryService {
  @WebappAPI
  void discoverZone(String probeID, DiscoverZone discoverZone) throws OverflowException;
  @WebappAPI
  void discoverHost(String probeID, Zone zone, DiscoverHost discoverHost) throws OverflowException;
  @WebappAPI
  void discoverPort(String probeID, Host host, DiscoverPort discoverPort) throws OverflowException;
  @WebappAPI
  void discoverService(String probeID, Port port, DiscoverService discoverService) throws OverflowException;

  @ProbeAPI
  void discoverStart(String requesterSessionID, Date startDate) throws OverflowException;
  @ProbeAPI
  void discoverStop(String requesterSessionID, Date stopDate) throws OverflowException;
  @ProbeAPI
  void discoveredZone(String requesterSessionID, Zone zone) throws OverflowException;
  @ProbeAPI
  void discoveredHost(String requesterSessionID, Host host) throws OverflowException;
  @ProbeAPI
  void discoveredPort(String requesterSessionID, Port port) throws OverflowException;
  @ProbeAPI
  void discoveredService(String requesterSessionID, Service service) throws OverflowException;
}
