package com.loafle.overflow.service.central.member;

import com.loafle.overflow.core.annotation.WebappAPI;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.domain.Domain;
import com.loafle.overflow.model.domain.DomainMember;
import com.loafle.overflow.model.member.Member;

import java.util.List;

/**
 * Created by geek on 17. 11. 7.
 */
public interface MemberService {
    @WebappAPI
    DomainMember signin(String signinId, String signinPw) throws OverflowException;
    @WebappAPI
    Member signup(Member member, String pw) throws OverflowException;
    @WebappAPI
    Member sendEmailForPassword(String email) throws OverflowException;
    @WebappAPI
    Member resetPassword(String encodeEmail, String pw) throws OverflowException;
    @WebappAPI
    Member modify(Member member, String pw) throws OverflowException;
    @WebappAPI
    Member forgotPassword(String signinId, String newPw) throws OverflowException;
    @WebappAPI
    Member read(long memberId) throws OverflowException;
    @WebappAPI
    void withdrawal(Member member) throws OverflowException;
    @WebappAPI
    List<Member> readAllByProbeKey(String probeKey) throws OverflowException;
    @WebappAPI
    List<Member> readAllByApiKey(String apikey) throws OverflowException;
    @WebappAPI
    List<Member> readAllByDomain(Domain domain) throws OverflowException;
    @WebappAPI
    List<Member> readAllByDomainID(final long domainID) throws OverflowException;
}
